<?php

class CmsStringsController extends AppController {

/**
 * Components
 *
 * @var array
 */
	public $components = array(
		'BuzzTranslate.Translation' => array(
			'fields' => array(
				'value'
			)
		)
	);

/**
 * List of admin actions the controller supports
 *
 * @var array
 */
	public $adminActions = array(
		'admin_index',
		'admin_edit'
	);

/**
 * Admin add/edit
 *
 * @param int $id
 * @return void
 */
	public function admin_edit($id = null) {
		$CmsString = $this->{$this->modelClass};

		parent::admin_edit($id);

		if ($id !== null) {

			unset($this->viewVars['fields'][$CmsString->alias . '.name']);
			unset($this->viewVars['fields'][$CmsString->alias . '.label']);

			// Update 'value' label with translated label from record.
			$label = TranslateUtil::translate(
				$this->request->data,
				$CmsString->alias . '.label'
			);
			$this->viewVars['fields'][$CmsString->alias . '.value']['label'] = $label;

			$this->Translation->settings['fields']['value'] = ['label' => $label];

		}

		$this->Translation->adminTranslationFormFields();
		return;
	}

	protected function _adminIndexActions() {
		return array(
			'Edit'
		);
	}

	protected function _adminIndexToolbar($id = null) {
		return [];
	}

	protected function _adminFormToolbar($id = null) {
		return [];
	}

}
