<?php

App::uses('Component', 'Controller');

/**
 * Site Setting component
 *
 * Doesn't do much appart load any site settings from the SiteSetting table
 * and makes them available to Configure::read('SiteSetting.foo')
 *
 * @package CoreCMS/SiteSetting
 */
class SiteSettingsComponent extends Component {

/**
 * create config entries for each site setting
 */
	public function initialize(Controller $Controller) {
		$Controller->loadModel('SiteSettings.SiteSetting');
		// NB: Cache is cleared after saving settings.
		$settings = Cache::remember('all_settings', function () use ($Controller) {
			return $Controller->SiteSetting->find('all');
		});
		foreach ($settings as $setting) {
			Configure::write('SiteSetting.' . $setting['SiteSetting']['name'], $setting['SiteSetting']['value']);
		}

		$Controller->loadModel('SiteSettings.CmsString');
		// NB: Cache is cleared after saving strings.
		$strings = Cache::remember('all_strings', function () use ($Controller) {
			return $Controller->CmsString->find('all');
		});
		foreach ($strings as $string) {
			Configure::write('String.' . $string['CmsString']['name'], ['value' => $string['CmsString']['value'], '__i18n' => $string['CmsString']['__i18n']]);
		}

		return parent::initialize($Controller);
	}

}
